Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Variable.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Variable.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Variable.cs	(revision 2202)
@@ -32,9 +32,10 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public class Variable : FunctionBase {
-
+  public class Variable : Terminal {    
     public const string WEIGHT = "Weight";
     public const string OFFSET = "SampleOffset";
     public const string INDEX = "Variable";
+
+    private BakedFunctionTree variableNodeTemplate;
 
     private int minOffset;
@@ -49,31 +50,35 @@
     }
 
+    public override IEnumerable<string> LocalParameterNames {
+      get {
+        return new string[] { WEIGHT, OFFSET, INDEX };
+      }
+    }
+
+    public override IFunctionTree GetTreeNode() {
+      return (IFunctionTree)variableNodeTemplate.Clone();
+    }
+
     public Variable()
       : base() {
-      AddVariableInfo(new VariableInfo(INDEX, "The variable name", typeof(StringData), VariableKind.None));
-      GetVariableInfo(INDEX).Local = true;
-      AddVariableInfo(new VariableInfo(WEIGHT, "Weight is multiplied to the feature value", typeof(DoubleData), VariableKind.None));
-      GetVariableInfo(WEIGHT).Local = true;
-      AddVariableInfo(new VariableInfo(OFFSET, "SampleOffset is added to the sample index", typeof(ConstrainedIntData), VariableKind.None));
-      GetVariableInfo(OFFSET).Local = true;
-      AddVariableInfo(new VariableInfo(INITIALIZATION, "Initialization operator for variables", typeof(CombinedOperator), VariableKind.None));
-      GetVariableInfo(INITIALIZATION).Local = false;
-      AddVariableInfo(new VariableInfo(MANIPULATION, "Manipulation operator for variables", typeof(CombinedOperator), VariableKind.None));
-      GetVariableInfo(MANIPULATION).Local = false;
+      //AddVariableInfo(new VariableInfo(INDEX, "The variable name", typeof(StringData), VariableKind.None));
+      //GetVariableInfo(INDEX).Local = true;
+      //AddVariableInfo(new VariableInfo(WEIGHT, "Weight is multiplied to the feature value", typeof(DoubleData), VariableKind.None));
+      //GetVariableInfo(WEIGHT).Local = true;
+      //AddVariableInfo(new VariableInfo(OFFSET, "SampleOffset is added to the sample index", typeof(ConstrainedIntData), VariableKind.None));
+      //GetVariableInfo(OFFSET).Local = true;
+      variableNodeTemplate = new BakedFunctionTree(this);
 
       DoubleData weight = new DoubleData();
-      AddVariable(new HeuristicLab.Core.Variable(WEIGHT, weight));
+      variableNodeTemplate.AddVariable(new HeuristicLab.Core.Variable(WEIGHT, weight));
 
       StringData variable = new StringData();
-      AddVariable(new HeuristicLab.Core.Variable(INDEX, variable));
+      variableNodeTemplate.AddVariable(new HeuristicLab.Core.Variable(INDEX, variable));
 
       ConstrainedIntData sampleOffset = new ConstrainedIntData();
-      AddVariable(new HeuristicLab.Core.Variable(OFFSET, sampleOffset));
+      variableNodeTemplate.AddVariable(new HeuristicLab.Core.Variable(OFFSET, sampleOffset));
 
       SetupInitialization();
       SetupManipulation();
-
-      // variable can't have suboperators
-      AddConstraint(new NumberOfSubOperatorsConstraint(0, 0));
     }
 
@@ -104,10 +109,5 @@
       seq.AddSubOperator(weightRandomizer);
       seq.AddSubOperator(offsetRandomizer);
-      HeuristicLab.Core.IVariable initOp = GetVariable(INITIALIZATION);
-      if(initOp == null) {
-        AddVariable(new HeuristicLab.Core.Variable(INITIALIZATION, combinedOp));
-      } else {
-        initOp.Value = combinedOp;
-      }
+      Initializer = combinedOp;
     }
 
@@ -139,14 +139,9 @@
       seq.AddSubOperator(weightRandomAdder);
       seq.AddSubOperator(offsetRandomAdder);
-      HeuristicLab.Core.IVariable manipulationOp = GetVariable(MANIPULATION);
-      if(manipulationOp == null) {
-        AddVariable(new HeuristicLab.Core.Variable(MANIPULATION, combinedOp));
-      } else {
-        manipulationOp.Value = combinedOp;
-      }
+      Manipulator = combinedOp;
     }
 
     public void SetConstraints(int minSampleOffset, int maxSampleOffset) {
-      ConstrainedIntData offset = GetVariableValue<ConstrainedIntData>(OFFSET, null, false);
+      ConstrainedIntData offset = (ConstrainedIntData)variableNodeTemplate.GetLocalVariable(OFFSET).Value;
       IntBoundedConstraint offsetConstraint = new IntBoundedConstraint();
       this.minOffset = minSampleOffset;
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Xor.cs
===================================================================
--- trunk/sources/HeuristicLab.GP.StructureIdentification/3.3/Xor.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP.StructureIdentification/3.3/Xor.cs	(revision 2202)
@@ -28,5 +28,5 @@
 
 namespace HeuristicLab.GP.StructureIdentification {
-  public sealed class Xor : FunctionBase {
+  public sealed class Xor : BinaryFunction {
     public override string Description {
       get {
@@ -37,7 +37,4 @@
     public Xor()
       : base() {
-      AddConstraint(new NumberOfSubOperatorsConstraint(2, 2));
-      AddConstraint(new SubOperatorTypeConstraint(0));
-      AddConstraint(new SubOperatorTypeConstraint(1));
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BakedFunctionTree.cs
===================================================================
--- trunk/sources/HeuristicLab.GP/3.3/BakedFunctionTree.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/BakedFunctionTree.cs	(revision 2202)
@@ -34,5 +34,5 @@
     public byte arity = 0;
     public IFunction functionType;
-    public List<object> localData = new List<object>();
+    public List<IVariable> localData = new List<IVariable>();
 
     public LightWeightFunction Clone() {
@@ -40,5 +40,5 @@
       clone.arity = arity;
       clone.functionType = functionType;
-      clone.localData.AddRange(localData);
+      clone.localData = localData.Select(v=>(IVariable)v.Clone()).ToList();
       return clone;
     }
@@ -57,5 +57,13 @@
     private List<IFunctionTree> subTrees;
     private bool variablesExpanded = false;
-    private List<IVariable> variables;
+    private List<IVariable> variables = new List<IVariable>();
+
+    public IOperator Initializer {
+      get { return Function.Initializer; }
+    }
+
+    public IOperator Manipulator {
+      get { return Function.Manipulator; }
+    }
 
     public BakedFunctionTree() {
@@ -63,5 +71,5 @@
     }
 
-    internal BakedFunctionTree(IFunction function)
+    public BakedFunctionTree(IFunction function)
       : this() {
       LightWeightFunction fun = new LightWeightFunction();
@@ -72,24 +80,19 @@
       variables = new List<IVariable>();
       variablesExpanded = true;
-      foreach (IVariableInfo variableInfo in function.VariableInfos) {
-        if (variableInfo.Local) {
-          variables.Add((IVariable)function.GetVariable(variableInfo.FormalName).Clone());
-        }
-      }
-    }
-
-    internal BakedFunctionTree(IFunctionTree tree)
-      : this() {
-      LightWeightFunction fun = new LightWeightFunction();
-      fun.functionType = tree.Function;
-      linearRepresentation.Add(fun);
-      foreach (IVariable variable in tree.LocalVariables) {
-        IObjectData value = (IObjectData)variable.Value;
-        fun.localData.Add(value.Data);
-      }
-      foreach (IFunctionTree subTree in tree.SubTrees) {
-        AddSubTree(new BakedFunctionTree(subTree));
-      }
-    }
+    }
+
+    //internal BakedFunctionTree(IFunctionTree tree)
+    //  : this() {
+    //  LightWeightFunction fun = new LightWeightFunction();
+    //  fun.functionType = tree.Function;
+    //  linearRepresentation.Add(fun);
+    //  foreach (IVariable variable in tree.LocalVariables) {
+    //    IObjectData value = (IObjectData)variable.Value;
+    //    fun.localData.Add(value.Data);
+    //  }
+    //  foreach (IFunctionTree subTree in tree.SubTrees) {
+    //    AddSubTree(new BakedFunctionTree(subTree));
+    //  }
+    //}
 
     private int BranchLength(int branchRoot) {
@@ -119,7 +122,8 @@
         linearRepresentation[0].localData.Clear();
         foreach (IVariable variable in variables) {
-          object objData = variable.Value;
-          while (objData is IObjectData) objData = ((IObjectData)objData).Data;
-          linearRepresentation[0].localData.Add(objData);
+          //object objData = variable.Value;
+          //while (objData is IObjectData) objData = ((IObjectData)objData).Data;
+          //linearRepresentation[0].localData[variable.Name] = objData;
+          linearRepresentation[0].localData.Add(variable);
         }
         variablesExpanded = false;
@@ -197,20 +201,17 @@
         if (!variablesExpanded) {
           variables = new List<IVariable>();
-          IFunction function = Function;
-          int localVariableIndex = 0;
-          foreach (IVariableInfo variableInfo in function.VariableInfos) {
-            if (variableInfo.Local) {
-              IVariable clone = (IVariable)function.GetVariable(variableInfo.FormalName).Clone();
-              IObjectData objData = (IObjectData)clone.Value;
-              if (objData is ConstrainedDoubleData) {
-                ((ConstrainedDoubleData)objData).Data = (double)linearRepresentation[0].localData[localVariableIndex];
-              } else if (objData is ConstrainedIntData) {
-                ((ConstrainedIntData)objData).Data = (int)linearRepresentation[0].localData[localVariableIndex];
-              } else {
-                objData.Data = linearRepresentation[0].localData[localVariableIndex];
-              }
-              variables.Add(clone);
-              localVariableIndex++;
-            }
+          IFunction function = Function;          
+          //int localVariableIndex = 0;
+          foreach (IVariable v in linearRepresentation[0].localData) {
+            //IObjectData objData = (IObjectData)clone.Value;
+            //if (objData is ConstrainedDoubleData) {
+            //  ((ConstrainedDoubleData)objData).Data = (double)linearRepresentation[0].localData[localVariableIndex];
+            //} else if (objData is ConstrainedIntData) {
+            //  ((ConstrainedIntData)objData).Data = (int)linearRepresentation[0].localData[localVariableIndex];
+            //} else {
+            //  objData.Data = linearRepresentation[0].localData[localVariableIndex];
+            //}
+            variables.Add(v);
+            //localVariableIndex++;
           }
           variablesExpanded = true;
@@ -233,9 +234,12 @@
 
     public void AddVariable(IVariable variable) {
-      throw new NotSupportedException();
+      if (!variablesExpanded) throw new InvalidOperationException();
+      if (!variables.Exists(v => v.Name == variable.Name))
+        variables.Add(variable);
     }
 
     public void RemoveVariable(string name) {
-      throw new NotSupportedException();
+      if (!variablesExpanded) throw new InvalidOperationException();
+      variables.RemoveAll(v => v.Name == name);
     }
 
@@ -256,25 +260,25 @@
     }
 
-    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      FlattenVariables();
-      FlattenTrees();
-      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
-      XmlNode linearRepresentationNode = document.CreateElement("LinearRepresentation");
-      foreach (LightWeightFunction f in linearRepresentation) {
-        XmlNode entryNode = PersistenceManager.Persist("Function", f.functionType, document, persistedObjects);
-        XmlAttribute arityAttribute = document.CreateAttribute("Arity");
-        arityAttribute.Value = XmlConvert.ToString(f.arity);
-        entryNode.Attributes.Append(arityAttribute);
-        foreach (object o in f.localData) {
-          if (f.localData.Count > 0) {
-            entryNode.AppendChild(CreateDataNode(document, o));
-          }
-        }
-        linearRepresentationNode.AppendChild(entryNode);
-      }
-
-      node.AppendChild(linearRepresentationNode);
-      return node;
-    }
+    //public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+    //  FlattenVariables();
+    //  FlattenTrees();
+    //  XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+    //  XmlNode linearRepresentationNode = document.CreateElement("LinearRepresentation");
+    //  foreach (LightWeightFunction f in linearRepresentation) {
+    //    XmlNode entryNode = PersistenceManager.Persist("Function", f.functionType, document, persistedObjects);
+    //    XmlAttribute arityAttribute = document.CreateAttribute("Arity");
+    //    arityAttribute.Value = XmlConvert.ToString(f.arity);
+    //    entryNode.Attributes.Append(arityAttribute);
+    //    foreach (object o in f.localData) {
+    //      if (f.localData.Count > 0) {
+    //        entryNode.AppendChild(CreateDataNode(document, o));
+    //      }
+    //    }
+    //    linearRepresentationNode.AppendChild(entryNode);
+    //  }
+
+    //  node.AppendChild(linearRepresentationNode);
+    //  return node;
+    //}
 
     private XmlNode CreateDataNode(XmlDocument doc, object o) {
@@ -295,19 +299,19 @@
     }
 
-    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      base.Populate(node, restoredObjects);
-      XmlNode linearRepresentationNode = node.SelectSingleNode("LinearRepresentation");
-      foreach (XmlNode entryNode in linearRepresentationNode.ChildNodes) {
-        LightWeightFunction f = new LightWeightFunction();
-        f.arity = XmlConvert.ToByte(entryNode.Attributes["Arity"].Value);
-        foreach (XmlNode dataNode in entryNode.ChildNodes) {
-          f.localData.Add(ParseDataNode(dataNode));
-        }
-        f.functionType = (IFunction)PersistenceManager.Restore(entryNode, restoredObjects);
-        linearRepresentation.Add(f);
-      }
-      treesExpanded = false;
-      variablesExpanded = false;
-    }
+    //public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+    //  base.Populate(node, restoredObjects);
+    //  XmlNode linearRepresentationNode = node.SelectSingleNode("LinearRepresentation");
+    //  foreach (XmlNode entryNode in linearRepresentationNode.ChildNodes) {
+    //    LightWeightFunction f = new LightWeightFunction();
+    //    f.arity = XmlConvert.ToByte(entryNode.Attributes["Arity"].Value);
+    //    foreach (XmlNode dataNode in entryNode.ChildNodes) {
+    //      f.localData.Add(ParseDataNode(dataNode));
+    //    }
+    //    f.functionType = (IFunction)PersistenceManager.Restore(entryNode, restoredObjects);
+    //    linearRepresentation.Add(f);
+    //  }
+    //  treesExpanded = false;
+    //  variablesExpanded = false;
+    //}
 
     private object ParseDataNode(XmlNode dataNode) {
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.Designer.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.Designer.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.Designer.cs	(revision 2202)
@@ -0,0 +1,32 @@
+﻿namespace HeuristicLab.GP {
+  partial class FunView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunView.cs	(revision 2202)
@@ -0,0 +1,26 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.GP {
+  public partial class FunView : ViewBase {
+    public IFunction Function {
+      get { return (IFunction)base.Item; }
+      set { base.Item = value; }
+    }
+
+    public FunView(IFunction function) : base() {      
+      InitializeComponent();
+    }
+
+    protected override void UpdateControls() {
+      base.UpdateControls();
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionBase.cs
===================================================================
--- trunk/sources/HeuristicLab.GP/3.3/FunctionBase.cs	(revision 2174)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionBase.cs	(revision 2202)
@@ -30,17 +30,78 @@
 
 namespace HeuristicLab.GP {
-  /// <summary>
-  /// Functions are like operators except that they do not allow sub-operators and the normal form of evaluation
-  /// is to evaluate all children first.
-  /// </summary>
-  public abstract class FunctionBase : OperatorBase, IFunction {
-    public const string INITIALIZATION = "Initialization";
-    public const string MANIPULATION = "Manipulation";
-    private List<IFunction>[] allowedSubFunctions;
+  public abstract class FunctionBase : ItemBase, IFunction {
+    private List<List<IFunction>> allowedSubFunctions = new List<List<IFunction>>();
     private int minArity = -1;
     private int maxArity = -1;
-
-    public virtual double Apply() {
-      throw new NotImplementedException();
+    private double tickets = 1.0;
+    private IOperator initializer;
+    private IOperator manipulator;
+    private int minTreeHeight = -1;
+    private int minTreeSize = -1;
+
+    public virtual string Name {
+      get { return this.GetType().Name; }
+    }
+
+    public virtual string Description {
+      get { return "Description for this function is missing (TODO)"; }
+    }
+
+    public int MinArity {
+      get {
+        return minArity;
+      }
+      protected set {
+        minArity = value;
+        while (minArity > allowedSubFunctions.Count) allowedSubFunctions.Add(new List<IFunction>());
+      }
+    }
+
+    public int MaxArity {
+      get {
+        return maxArity;
+      }
+      protected set {
+        maxArity = value;
+        while (allowedSubFunctions.Count > maxArity) allowedSubFunctions.RemoveAt(allowedSubFunctions.Count - 1);
+        while (maxArity > allowedSubFunctions.Count) allowedSubFunctions.Add(new List<IFunction>());
+      }
+    }
+
+
+    public int MinTreeSize {
+      get {
+        if (minTreeSize <= 0) RecalculateMinimalTreeSize();
+        return minTreeSize;
+      }
+    }
+
+    public int MinTreeHeight {
+      get {
+        if (minTreeHeight <= 0) RecalculateMinimalTreeHeight();
+        return minTreeHeight;
+      }
+    }
+
+    public double Tickets {
+      get { return tickets; }
+      set {
+        if (value < 0.0) throw new ArgumentException("Number of tickets must be positive");
+        else tickets = value;
+      }
+    }
+
+    public IOperator Initializer {
+      get { return initializer; }
+      set { initializer = value; }
+    }
+
+    public IOperator Manipulator {
+      get { return manipulator; }
+      set { manipulator = value; }
+    }
+
+    public virtual IEnumerable<string> LocalParameterNames {
+      get { return new string[0]; }
     }
 
@@ -49,108 +110,104 @@
     }
 
-    public int MinArity {
-      get {
-        if(minArity < 0) RefreshArity();
-        return minArity;
-      }
-    }
-
-    public int MaxArity {
-      get {
-        if(maxArity < 0) RefreshArity();
-        return maxArity;
-      }
-    }
-
-    private void RefreshArity() {
-      minArity = 2; maxArity = 2; // default arity is 2
-      foreach(IConstraint constraint in Constraints) {
-        NumberOfSubOperatorsConstraint theConstraint = constraint as NumberOfSubOperatorsConstraint;
-        if(theConstraint != null) {
-          minArity = theConstraint.MinOperators.Data;
-          maxArity = theConstraint.MaxOperators.Data;
+
+    //private List<IConstraint> constraints = new List<IConstraint>();
+    //public ICollection<IConstraint> Constraints {
+    //  get { return constraints; }
+    //}
+
+    //private void RefreshArity() {
+    //  minArity = 2; maxArity = 2; // default arity is 2
+    //  foreach (IConstraint constraint in Constraints) {
+    //    NumberOfSubOperatorsConstraint theConstraint = constraint as NumberOfSubOperatorsConstraint;
+    //    if (theConstraint != null) {
+    //      minArity = theConstraint.MinOperators.Data;
+    //      maxArity = theConstraint.MaxOperators.Data;
+    //    }
+    //  }
+    //}
+
+    public ICollection<IFunction> GetAllowedSubFunctions(int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      //if (allowedSubFunctions == null) {
+      //  // first time: analyze the constraint and create a cached copy of the allowed sub-functions
+      //  allowedSubFunctions = new List<IFunction>[MaxArity];
+      //  for (int i = 0; i < MaxArity; i++) {
+      //    allowedSubFunctions[i] = GetAllowedSubFunctions(i);
+      //  }
+      //}
+      return allowedSubFunctions[index];
+    }
+
+    public void AddAllowedSubFunction(IFunction function, int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      if (allowedSubFunctions[index] == null) {
+        allowedSubFunctions[index] = new List<IFunction>();
+      }
+      if (!allowedSubFunctions[index].Contains(function)) {
+        allowedSubFunctions[index].Add(function);
+      }
+    }
+
+    public void RemoveAllowedSubFunction(IFunction function, int index) {
+      if (index < 0 || index > MaxArity) throw new ArgumentException("Index outside of allowed range. index = " + index);
+      allowedSubFunctions[index].Add(function);
+    }
+
+    public bool IsAllowedSubFunction(IFunction function, int index) {
+      return GetAllowedSubFunctions(index).Contains(function);
+    }
+
+    //private List<IFunction> GetAllowedSubFunctions(int index) {
+    //  List<IFunction> allowedSubFunctions = new List<IFunction>();
+    //  foreach (IConstraint constraint in Constraints) {
+    //    if (constraint is SubOperatorTypeConstraint) {
+    //      SubOperatorTypeConstraint subOpConstraint = constraint as SubOperatorTypeConstraint;
+    //      if (subOpConstraint.SubOperatorIndex.Data == index) {
+    //        foreach (IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
+    //        subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraint changes
+    //        return allowedSubFunctions;
+    //      }
+    //    } else if (constraint is AllSubOperatorsTypeConstraint) {
+    //      AllSubOperatorsTypeConstraint subOpConstraint = constraint as AllSubOperatorsTypeConstraint;
+    //      foreach (IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
+    //      subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraint changes
+    //      return allowedSubFunctions;
+    //    }
+    //  }
+    //  return allowedSubFunctions;
+    //}
+
+    //private void subOpConstraint_Changed(object sender, EventArgs e) {
+    //  allowedSubFunctions = null;
+    //}
+
+    public override IView CreateView() {
+      return new FunView(this);
+    }
+
+    private void RecalculateMinimalTreeSize() {
+      minTreeSize = int.MaxValue;
+      int sum = 1;
+      int minSize = int.MaxValue;
+      for (int i = 0; i < MinArity; i++) {
+        foreach (IFunction subFun in GetAllowedSubFunctions(i)) {
+          minSize = Math.Min(minSize, subFun.MinTreeSize);
         }
-      }
-    }
-
-    public IList<IFunction> AllowedSubFunctions(int index) {
-      if(allowedSubFunctions == null) {
-        // first time: analyze the constraint and create a cached copy of the allowed sub-functions
-        allowedSubFunctions = new List<IFunction>[MaxArity];
-        for(int i = 0; i < MaxArity; i++) {
-          allowedSubFunctions[i] = GetAllowedSubFunctions(i);
+        sum += minSize;
+      }
+      minTreeSize = sum;
+    }
+
+    private void RecalculateMinimalTreeHeight() {
+      minTreeHeight = int.MaxValue;
+      int height = 0;
+      int minHeight = int.MaxValue;
+      for (int i = 0; i < MinArity; i++) {
+        foreach (IFunction subFun in GetAllowedSubFunctions(i)) {
+          minHeight = Math.Min(minHeight, subFun.MinTreeHeight);
         }
-      }
-      return allowedSubFunctions[index];
-    }
-
-    private List<IFunction> GetAllowedSubFunctions(int index) {
-      List<IFunction> allowedSubFunctions = new List<IFunction>();
-      foreach(IConstraint constraint in Constraints) {
-        if(constraint is SubOperatorTypeConstraint) {
-          SubOperatorTypeConstraint subOpConstraint = constraint as SubOperatorTypeConstraint;
-          if(subOpConstraint.SubOperatorIndex.Data == index) {
-            foreach(IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
-            subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraing changes
-            return allowedSubFunctions;
-          }
-        } else if(constraint is AllSubOperatorsTypeConstraint) {
-          AllSubOperatorsTypeConstraint subOpConstraint = constraint as AllSubOperatorsTypeConstraint;
-          foreach(IFunction f in subOpConstraint.AllowedSubOperators) allowedSubFunctions.Add(f);
-          subOpConstraint.Changed += new EventHandler(subOpConstraint_Changed); // register an event-handler to invalidate the cache on constraint changes
-          return allowedSubFunctions;
-        }
-      }
-      return allowedSubFunctions;
-    }
-
-    private void subOpConstraint_Changed(object sender, EventArgs e) {
-      allowedSubFunctions = null;
-    }
-
-    // operator-tree style evaluation is not supported for functions.
-    public override IOperation Apply(IScope scope) {
-      throw new NotSupportedException();
-    }
-
-    private static readonly List<IOperator> emptySubOperatorList = new List<IOperator>();
-    public override IList<IOperator> SubOperators {
-      get { return emptySubOperatorList; }
-    }
-
-    public override void AddSubOperator(IOperator subOperator) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryAddSubOperator(IOperator subOperator) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryAddSubOperator(IOperator subOperator, int index) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryAddSubOperator(IOperator subOperator, int index, out ICollection<IConstraint> violatedConstraints) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryAddSubOperator(IOperator subOperator, out ICollection<IConstraint> violatedConstraints) {
-      throw new NotSupportedException();
-    }
-
-    public override void AddSubOperator(IOperator subOperator, int index) {
-      throw new NotSupportedException();
-    }
-
-    public override void RemoveSubOperator(int index) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryRemoveSubOperator(int index) {
-      throw new NotSupportedException();
-    }
-
-    public override bool TryRemoveSubOperator(int index, out ICollection<IConstraint> violatedConstraints) {
-      throw new NotSupportedException();
+        height = Math.Max(height, minHeight);
+      }
+      minTreeHeight = height + 1;
     }
   }
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionGroup.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionGroup.cs	(revision 2202)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionGroup.cs	(revision 2202)
@@ -0,0 +1,34 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Data;
+using HeuristicLab.Random;
+using HeuristicLab.Constraints;
+
+namespace HeuristicLab.GP {
+  public class FunctionGroup : StorableBase {
+}
